variables:
  PROD_SERVER_IP: 157.230.31.23
  PROD_SERVER_USER: root
stages:
  - test
  - prep
  - deploy
MicroCI_test:
  stage: test
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner -Dsonar.qualitygate.wait=true
MicroCI_prep:
  stage: prep
  before_script:
    - chmod 400 $SSH_KEY
    - chmod 400 $SSH_PUB
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - cp $SSH_KEY ~/.ssh/id_rsa
    - cp $SSH_PUB ~/.ssh/id_rsa.pub
  script:
    - ssh -o StrictHostKeyChecking=no root@$PROD_SERVER_IP "
        apt -y install docker.io docker-compose || true"
MicroCI_deploy:
  stage: deploy
  image: docker
  services:
    - docker:dind
  before_script:
    - chmod 400 $SSH_KEY
    - chmod 400 $SSH_PUB
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - cp $SSH_KEY ~/.ssh/id_rsa
    - cp $SSH_PUB ~/.ssh/id_rsa.pub
    - ssh -o StrictHostKeyChecking=no root@$PROD_SERVER_IP "dpkg -s docker.io docker-compose"
  script:
    - docker-compose -H "ssh://$PROD_SERVER_USER@$PROD_SERVER_IP" 
        -f srv/docker-compose.yml down --remove-orphans
    - docker-compose -H "ssh://$PROD_SERVER_USER@$PROD_SERVER_IP" 
        -f srv/docker-compose.yml up -d
    - sleep 60
    - docker-compose -H "ssh://$PROD_SERVER_USER@$PROD_SERVER_IP" 
        -f microservice/docker-compose.yml up -d

